<template>
    <span v-html="message()"></span>
    <font-awesome-icon icon="fa-triangle-exclamation" class="color_gold" v-if="changedIconOn && is_changed" />
</template>

<script>
import { useParseRulesStore } from "@/js/stores/RulesStore";
import { useParseTestsStore } from "@/js/stores/TestsStore";
import { compile } from "vue/dist/vue.esm-bundler.js";
import { computed } from "vue";

export default {
    props: {
        template: String,
    },
    setup() {
        const RulesStore = useParseRulesStore();
        const TestsStore = useParseTestsStore();

        return {
            RulesStore,
            TestsStore,
            is_changed: computed(() => RulesStore.hasChanges),
            correctPercent: computed(() => TestsStore.correctPercent),
            correctCount: computed(() => TestsStore.correctCount),
            testsCount: computed(() => TestsStore.testsCount),
        };
    },
    data() {
        return {
            changedIconOn: false,
        };
    },
    methods: {
        message() {
            return compile(this.template)(this.$.ctx);
        },
        changedIcon() {
            this.changedIconOn = true;
        },
        testPercent() {
            return (
                '<b class="color_' +
                (this.correctPercent === 100 ? "green" : "red") +
                '">' +
                this.correctPercent +
                "% (" +
                this.correctCount +
                " / " +
                this.testsCount +
                ") </b>"
            );
        },
    },
};
</script>

<style>
.color_gold {
    color: gold;
}
.color_red {
    color: darkred;
}
.color_green {
    color: darkgreen;
}
</style>
